uniform sampler2D u_texture;
uniform lowp float u_glimmerFactor;
uniform highp float u_alpha;

varying highp float v_roadness;
varying highp float v_glimmer;
varying highp vec2 v_uv;

const highp float fogDensity = 0.4;
const highp float LOG2 = 1.442695;

void main()
{

    highp float z = gl_FragCoord.z / gl_FragCoord.w;
    highp float fogFactor = exp2(-fogDensity * fogDensity * z * z * LOG2);
    fogFactor = clamp(fogFactor, 0.0, 1.0);
    
    lowp vec4 color = texture2D(u_texture, v_uv, -0.75);
    color.rgb += (v_glimmer * color.rgb * 0.8 + vec3(v_glimmer) * 0.2) * u_glimmerFactor;
    color.rgb += 0.05 * (1.0 - fogFactor);
    color *= u_alpha;

    gl_FragColor = color;
}
