uniform sampler2D u_texture;
varying highp vec2 v_uv;

const highp float fogDensity = 1.1;
const highp float LOG2 = 1.442695;



void main()
{
    highp float z = gl_FragCoord.z / gl_FragCoord.w;
    z /= 15.0;
    highp float fogFactor = exp2(-fogDensity * fogDensity * z * z * LOG2);
    fogFactor = clamp(fogFactor, 0.0, 1.0);
    
    lowp vec4 color = texture2D(u_texture, v_uv);
    color.a = fogFactor * fogFactor * fogFactor + 0.1;
    color.a = clamp(color.a, 0.0, 1.0);
    color.rgb *= color.a;

    gl_FragColor = color;
}