attribute vec4 a_position;
attribute vec2 a_uv;

uniform float u_noiseAmount;
uniform sampler2D u_texture;
uniform mat4 u_projectionmodel;

varying vec2 v_uv;

const vec2 noiseCenter = vec2(1.0/4.0, 1.0/4.0);

void main(void)
{
    v_uv = a_uv;
    
    
    vec4 position = a_position;
    vec2 noisePos = (position.xz / 32.0) * (2.0/4.0);
    
    float noise = texture2D(u_texture, noiseCenter + noisePos).r;
    
    position.y += noise * 4.0;
    gl_Position = u_projectionmodel * position;
}