uniform sampler2D u_texture;
uniform lowp vec4 u_color;
varying highp vec2 v_uv;

const highp float fogDensity = 0.4;
const highp float LOG2 = 1.442695;

void main()
{
    highp float z = gl_FragCoord.z / gl_FragCoord.w;
    highp float fogFactor = exp2(-fogDensity * fogDensity * z * z * LOG2);
    fogFactor = clamp(fogFactor, 0.0, 1.0);
    gl_FragColor = u_color * smoothstep(0.0, 0.8, fogFactor);
}